/*	SampleApp.cpp	*/
/*	$Id: SampleApp.cpp,v 1.1 1997/06/06 18:37:19 hplus Exp hplus $	*/

#include <Application.h>
#include <Window.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "Preferences.h"


class MyWindow : public BWindow
{
public:
								MyWindow(BRect area, const char * title, window_type kind, uint32 flags);
		bool					QuitRequested();
};


Preferences gPrefs("x-PREF-SampleApp");
PreferenceSet gSettings(gPrefs, "settings", true);

void
main()
{
	if (gPrefs.InitCheck())
	{
		puts("Cannot initialize preferences");
		exit(1);
	}
	if (gSettings.InitCheck())
	{
		puts("Cannot get settings");
		exit(1);
	}
	BApplication app("application/x-PREF-SampleApp");
	BRect area;
	const void * data;
	size_t size;
	uint32 type = '    ';
	if (gSettings.GetData("frame", data, size, type) || (type != B_RECT_TYPE))
		area.Set(100,50, 500,400);
	else
		memcpy(&area, data, size);
	MyWindow *w = new MyWindow(area, "Move Me", B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE);
	w->Show();
	app.Run();
}


static void
win_pref_func(
	PREFData			data,
	void *				cookie)
{
	/*	if this is an update we're interested in, update ourselves		*/
	if ((data == gSettings) && (cookie != NULL))
	{
		printf("reload = %08x\n", PREFReloadSet(data));
		const void * data;
		BRect area;
		size_t size;
		uint32 type = '    ';
		if (!gSettings.GetData("frame", data, size, type) && (type == B_RECT_TYPE))
		{
			/*	we got a new position - use it!	*/
			memcpy(&area, data, sizeof(BRect));
			((BWindow *)cookie)->Lock();
			((BWindow *)cookie)->MoveTo(area.LeftTop());
			((BWindow *)cookie)->ResizeTo(area.Width(), area.Height());
			((BWindow *)cookie)->Unlock();
		}
	}
}


MyWindow::MyWindow(BRect area, const char * title, window_type kind, uint32 flags) :
	BWindow(area, title, kind, flags)
{
	/*	start listening	*/
	printf("listen = %08x\n", PREFListen(gSettings, win_pref_func, (BWindow *)this));
}


bool
MyWindow::QuitRequested()
{
	/*	stop listening	*/
	PREFListen(gSettings, NULL, NULL);

	/*	save our position	*/
	BRect frame = Frame();
	if (gSettings.SetData("frame", &frame, sizeof(frame), B_RECT_TYPE))
		puts("Cannot set frame");
	else if (gSettings.Save())
		puts("Cannot save settings");
	be_app->PostMessage(B_QUIT_REQUESTED);
	return true;
}

